/[MITgcm]/MITgcm/verification/testreport
ViewVC logotype

Diff of /MITgcm/verification/testreport

Parent Directory Parent Directory | Revision Log Revision Log | View Revision Graph Revision Graph | View Patch Patch

revision 1.77 by jmc, Mon Mar 20 21:50:36 2006 UTC revision 1.112 by jmc, Sat Feb 9 18:30:25 2008 UTC
# Line 11  usage() Line 11  usage()
11      echo      echo
12      echo "where possible OPTIONS are:"      echo "where possible OPTIONS are:"
13      echo "  (-help|-h)               print usage"      echo "  (-help|-h)               print usage"
14      echo "  (-mpi)                   use MPI input files"      echo "  (-mth)                   run multi threaded (using eedata.mth)"
15        echo "  (-mpi)                   compile and run using MPI"
16      echo "  (-ieee|-noieee)          if possible, use IEEE compiler flags"      echo "  (-ieee|-noieee)          if possible, use IEEE compiler flags"
17      echo "                             (DEF=\"-ieee\")"      echo "                             (DEF=\"-ieee\")"
18      echo "  (-optfile=|-of=)STRING   list of optfiles to use"      echo "  (-gsl)                   compile with \"-gsl\" flag"
19        echo "  (-of=|-optfile=)STRING   list of optfiles to use"
20      echo "  (-a|-addr) STRING        list of email recipients"      echo "  (-a|-addr) STRING        list of email recipients"
21      echo "                             (DEF=\"edhill@mitgcm.org\")"      echo "                             (DEF=\"\" no email is sent)"
22      echo "  (-t|-tdir) STRING        list of test dirs to use"      echo "  (-t|-tdir) STRING        list of group and/or exp. dirs to test"
23      echo "                             (DEF=\"\" which builds all)"      echo "                             (recognized groups: basic, tutorials)"
24        echo "                             (DEF=\"\" which test all)"
25        echo "  (-skd|-skipdir) STRING   list of exp. dirs to skip"
26        echo "                             (DEF=\"\" which test all)"
27      echo "  (-b|-bash) STRING        preferred location of a \"bash\" or"      echo "  (-b|-bash) STRING        preferred location of a \"bash\" or"
28      echo "                             Bourne-compatible \"sh\" shell"      echo "                             Bourne-compatible \"sh\" shell"
29      echo "                             (DEF=\"\" for \"bash\")"      echo "                             (DEF=\"\" for \"bash\")"
# Line 29  usage() Line 34  usage()
34      echo "                             (DEF=\"make\")"      echo "                             (DEF=\"make\")"
35      echo "  (-odir) STRING           used to build output directory name"      echo "  (-odir) STRING           used to build output directory name"
36      echo "                             (DEF=\"hostname\")"      echo "                             (DEF=\"hostname\")"
37      echo "  (-ptracers|-ptr) STRING  specify which ptracers to test"      echo "  (-ptr|-ptracers) STRING  specify which ptracers to test"
38      echo "                             (DEF=\"1 2 3 4 5\")"      echo "                             (DEF=\"1 2 3 4 5\")"
39        echo "  (-match) NUMBER          Matching Criteria (number of digits)"
40        echo "                             (DEF=\"12\")"
41      echo "  (-j) JOBS                use \"make -j JOBS\" for parallel builds"      echo "  (-j) JOBS                use \"make -j JOBS\" for parallel builds"
42      echo "  (-clean)                 *ONLY* run \"make CLEAN\""      echo "  (-clean)                 *ONLY* run \"make CLEAN\""
43      echo "  (-quick|-q)              same as \"-nogenmake -noclean -nodepend\""      echo "  (-quick|-q)              same as \"-nogenmake -noclean -nodepend\""
# Line 38  usage() Line 45  usage()
45      echo "  (-noclean|-nc)           skip the \"make clean\" stage"      echo "  (-noclean|-nc)           skip the \"make clean\" stage"
46      echo "  (-nodepend|-nd)          skip the \"make depend\" stage"      echo "  (-nodepend|-nd)          skip the \"make depend\" stage"
47      echo "  (-deldir|-dd)            on success, delete the output directory"      echo "  (-deldir|-dd)            on success, delete the output directory"
48        echo "  (-ts)                    provide timing information per timestep"
49        echo "  (-papis)                 provide MFlop/s per timestep using PAPI"
50        echo "  (-pcls)                  provide MFlop/s per timestep using PCL"
51      echo      echo
52      echo "and where STRING can be a whitespace-delimited list"      echo "and where STRING can be a whitespace-delimited list"
53      echo "such as:"      echo "such as:"
# Line 64  build_mpack() Line 74  build_mpack()
74              echo              echo
75              HAVE_MPACK=f              HAVE_MPACK=f
76          fi          fi
         printf "building mpack...  "  
77          if test "x$CC" = x ; then          if test "x$CC" = x ; then
78              export CC=cc              export CC=cc
79          fi          fi
80            printf "building mpack (using CC=$CC)...  "
81          ( cd $MPACKDIR && ./configure && $MAKE ) > tr_build_mpack.out 2>&1          ( cd $MPACKDIR && ./configure && $MAKE ) > tr_build_mpack.out 2>&1
82          RETVAL=$?          RETVAL=$?
83          if test "x$RETVAL" != x0 ; then          if test "x$RETVAL" != x0 ; then
# Line 78  build_mpack() Line 88  build_mpack()
88          else          else
89              rm -f tr_build_mpack.out              rm -f tr_build_mpack.out
90              HAVE_MPACK=t              HAVE_MPACK=t
91                echo "OK"
92          fi          fi
93      else      else
94          HAVE_MPACK=t          HAVE_MPACK=t
95            echo "done"
96      fi      fi
     echo "OK"  
97  }  }
98    
99  testoutput_for_prop()  testoutput_var()
100  {  {
101      # testoutput_for_prop dir s1 label subdir extension      # testoutput_var dir s1 label subdir reference_output
102      #      #
103      #  compares files in $dir/$subdir/output.txt and $dir/results/output.txt      #  compares 1 variable output selected from file $dir/$subdir/$OUTPUTFILE
104      #  using search strings s1 and text label      #     with same output from reference file $dir/results/$reference_output
105        #  using search strings s1 and text label
106    
107      if [ $debug -gt 0 ]; then      if [ $debug -gt 0 ]; then
108          echo testoutput_for_prop: grep "$2" $1/$4/output.txt 1>&2          echo testoutput_var: grep "$2" $1/$4/$OUTPUTFILE 1>&2
109      fi      fi
110      if [ -r $1/$4/output.txt ]; then      if [ -r $1/$4/$OUTPUTFILE ]; then
111          grep "$2" $1/$4/output.txt | sed 's/.*=//' | cat -n > tmp1.txt          grep "$2" $1/$4/$OUTPUTFILE | sed 's/.*=//' | cat -n > tmp1.txt
112          lncntA=`wc -l tmp1.txt | awk '{print $1}' `          lncntA=`wc -l tmp1.txt | awk '{print $1}' `
113          if [ $lncntA -lt 3 ]; then          if [ $lncntA -lt 2 ]; then
114              if [ $verbose -gt 0 ]; then              if [ $verbose -gt 0 ]; then
115                  echo Not enough lines of output when searching for "$2" 1>&2                  echo Not enough lines of output when searching for "$2" 1>&2
116              fi              fi
117              return 99              return 99
118          fi          fi
119      else      else
120          echo testoutput_for_prop: output.txt from model run was not readable 1>&2          echo testoutput_var: $OUTPUTFILE from model run was not readable 1>&2
121          return 99          return 99
122      fi      fi
123      if [ $debug -gt 0 ]; then      if [ $debug -gt 0 ]; then
124          echo testoutput_for_prop: grep "$2" $1/results/output.txt$5 1>&2          echo testoutput_var: grep "$2" $1/results/$5 1>&2
125      fi      fi
126      grep "$2" $1/results/output.txt$5 | sed 's/.*=//' | cat -n > tmp2.txt      grep "$2" $1/results/$5 | sed 's/.*=//' | cat -n > tmp2.txt
127      lncntB=`wc -l tmp2.txt | awk '{print $1}' `      lncntB=`wc -l tmp2.txt | awk '{print $1}' `
128      if [ $lncntB -lt 3 ]; then      if [ $lncntB -lt 2 ]; then
129          if [ $verbose -gt 0 ]; then          if [ $verbose -gt 0 ]; then
130              echo Not enough lines of output when searching for "$2" 1>&2              echo Not enough lines of output when searching for "$2" 1>&2
131          fi          fi
# Line 127  testoutput_for_prop() Line 139  testoutput_for_prop()
139      fi      fi
140      has_nan=`cat tmp1.txt | grep -i nan | wc -l`      has_nan=`cat tmp1.txt | grep -i nan | wc -l`
141      if [ $has_nan -gt 0  ] ; then      if [ $has_nan -gt 0  ] ; then
142          echo testoutput_for_prop: output.txt contains $has_nan NaN values  1>&2          echo testoutput_var: $OUTPUTFILE contains $has_nan NaN values  1>&2
143          return 99          return 99
144      fi      fi
145      has_inf=`cat tmp1.txt | grep -i inf | wc -l`      has_inf=`cat tmp1.txt | grep -i inf | wc -l`
146      if [ $has_inf -gt 0  ] ; then      if [ $has_inf -gt 0  ] ; then
147          echo testoutput_for_prop: output.txt contains $has_inf Inf values  1>&2          echo testoutput_var: $OUTPUTFILE contains $has_inf Inf values  1>&2
148          return 99          return 99
149      fi      fi
150      if [ $debug -gt 0 ]; then      if [ $debug -gt 0 ]; then
151          echo testoutput_for_prop: join tmp1.txt tmp2.txt 1>&2          echo testoutput_var: join tmp1.txt tmp2.txt 1>&2
152      fi      fi
153      join tmp1.txt tmp2.txt | awk '{print $1 " " $2 " " $3}' > tmp3.txt      join tmp1.txt tmp2.txt | awk '{print $1 " " $2 " " $3}' > tmp3.txt
154      if [ $debug -gt 0 ]; then      if [ $debug -gt 0 ]; then
155          echo testoutput_for_prop: compare_lines 1>&2          echo testoutput_var: compare_lines 1>&2
156      fi      fi
157      if [ $verbose -gt 1 ]; then      if [ $verbose -gt 1 ]; then
158          cat tmp3.txt 1>&2          cat tmp3.txt 1>&2
# Line 148  testoutput_for_prop() Line 160  testoutput_for_prop()
160      echo "-1" >> tmp3.txt      echo "-1" >> tmp3.txt
161      # On the SGI O3K (*not* the O2K), "cat -n" inserts a ":" after the line number      # On the SGI O3K (*not* the O2K), "cat -n" inserts a ":" after the line number
162      cat tmp3.txt | sed -e 's|:||g' > tmp4.txt      cat tmp3.txt | sed -e 's|:||g' > tmp4.txt
163      digits_of_similarity=`./tmp_cmpnum < tmp4.txt`      digits_of_similarity=`./tr_cmpnum < tmp4.txt`
164      if [ $digits_of_similarity -eq 99 ]; then      if [ $digits_of_similarity -eq 99 ]; then
165          if [ $verbose -gt 0 ]; then          if [ $verbose -gt 0 ]; then
166              echo testoutput_for_prop: No comparison was available for \"$2\" 1>&2              echo testoutput_var: No comparison was available for \"$3\" 1>&2
167          fi          fi
168          digits_of_similarity=99          digits_of_similarity=99
169      else      else
170          if [ $verbose -gt 0 ]; then          if [ $verbose -gt 0 ]; then
171              echo There were $digits_of_similarity decimal places of similarity for \"$2\" 1>&2              echo There were $digits_of_similarity decimal places of similarity for \"$3\" 1>&2
172          fi          fi
173      fi      fi
174      rm -f tmp1.txt tmp2.txt tmp3.txt tmp4.txt      rm -f tmp1.txt tmp2.txt tmp3.txt tmp4.txt
# Line 164  testoutput_for_prop() Line 176  testoutput_for_prop()
176      return $digits_of_similarity      return $digits_of_similarity
177  }  }
178    
 dashnum()  
 {  
     # dashnum n1 n2 n3 ...  
     #  
     #  print numbers using %3i format or "--" if number = 99  
   
     for num in $@ ; do  
         if [ $num = 99 ]; then  
             printf ' --'  
         else  
             printf '%3i' $num  
         fi  
     done  
 }  
   
 testoutput_ad()  
 {  
     grep $3 $1/results_ad/output.txt_adm | awk '{print NR " " $5}' > t05.txt  
     grep $3 $1/$2/output.txt_adm | awk '{print NR " " $5}' > t15.txt  
     grep $3 $1/results_ad/output.txt_adm | awk '{print NR " " $6}' > t06.txt  
     grep $3 $1/$2/output.txt_adm | awk '{print NR " " $6}' > t16.txt  
     join t05.txt t15.txt > t5.txt  
     join t06.txt t16.txt > t6.txt  
     echo "-1" >> t5.txt  
     echo "-1" >> t6.txt  
     digits_5=`./tmp_cmpnum < t5.txt`  
     digits_6=`./tmp_cmpnum < t6.txt`  
     dashnum $digits_5 $digits_6  
     rm -f t[01][56].txt t[56].txt  
 }  
   
179  check_for_add_mon_output()  check_for_add_mon_output()
180  {  {
181      # Check for additional types of monitor output      # Check for additional types of monitor output
# Line 220  check_for_add_mon_output() Line 201  check_for_add_mon_output()
201      done      done
202  }  }
203    
204  testoutput()  testoutput_run()
205  {  {
206      # testoutput directory subdir extension      # testoutput_run directory subdir reference_output
207      #      #
208      #  test output in "directory"      #  test output from 1 run in "directory"
209      if test "x$ADM" = x ; then  # --> same processing for adjoint & forward test
210          if [ $debug -gt 0 ]; then          # default list of output variables to be checked:
211              echo testoutput: testoutput_for_prop $1 cg2d_init_res 1>&2          #  1rst : main variable used to decide if it pass or FAIL
212          fi          #  others : number of matching digits to be printed in summary.txt
213          testoutput_for_prop $1 "cg2d_init_res" "cg2d init. residual" $2 $3; cg2dres=$?          listChk=$DEF_CHECK_LIST
214          if [ $debug -gt 0 ]; then          #  load experiment-specific list from file "tr_checklist" (if it exist)
215              echo testoutput: cg2dres=$cg2dres 1>&2          if test -r $1/$2/tr_checklist ; then listChk=`cat $1/$2/tr_checklist` ; fi
216          fi          sVar=`echo $listChk | awk '{print $1}'`
217          testoutput_for_prop $1 "dynstat_theta_min" "theta minimum" $2 $3; tmin=$?          # remove 1rst var and expand the list: + => min max mean s.d
218          testoutput_for_prop $1 "dynstat_theta_max" "theta maximum" $2 $3; tmax=$?          listVar=`echo $listChk | sed 's/ [a-zA-Z0-9]*+/&mn &mx &av &sd/g' \
219          testoutput_for_prop $1 "dynstat_theta_mean" "theta mean" $2 $3; tmean=$?                                 | sed 's/+//g' | sed "s/^$sVar//"`
220          testoutput_for_prop $1 "dynstat_theta_sd" "theta s.d." $2 $3; tsd=$?          if [ $debug -gt 0 ]; then echo "testoutput_run: listVar(I)='$listVar'" 1>&2 ; fi
221          testoutput_for_prop $1 "dynstat_salt_min" "salt minimum" $2 $3; smin=$?          for ii in 1 2 3 4 5 6 7 8 9 ; do
222          testoutput_for_prop $1 "dynstat_salt_max" "salt maximum" $2 $3; smax=$?            tst=`eval 'echo "$HAVE_PTR0'$ii'"'`
223          testoutput_for_prop $1 "dynstat_salt_mean" "salt mean" $2 $3; smean=$?           #echo "-- ptr test=" $tst "number of var=" `echo $listVar | awk '{print NF}'` 1>&2
224          testoutput_for_prop $1 "dynstat_salt_sd" "salt s.d." $2 $3; ssd=$?            if test "x$tst" != xt ; then listVar=`echo "$listVar" | sed "s/ pt$ii..//g"` ; fi
225          testoutput_for_prop $1 "dynstat_uvel_min" "U minimum" $2 $3; umin=$?          done
226          testoutput_for_prop $1 "dynstat_uvel_max" "U maximum" $2 $3; umax=$?          tst=`echo $sVar $listVar | awk '{ for(i=2;i<=NF;i++){t+=($i==$1)}; print t }'`
227          testoutput_for_prop $1 "dynstat_uvel_mean" "U mean" $2 $3; umean=$?          if test $tst != 1 ; then
228          testoutput_for_prop $1 "dynstat_uvel_sd" "U s.d." $2 $3; usd=$?            if test $tst = 0 ; then echo "==> WARNING: selected var >$sVar< not found" 1>&2
229          testoutput_for_prop $1 "dynstat_vvel_min" "V minimum" $2 $3; vmin=$?                   else echo "==> WARNING: found selected var >$sVar< $tst times" 1>&2 ; fi
230          testoutput_for_prop $1 "dynstat_vvel_max" "V maximum" $2 $3; vmax=$?            echo "==> WARNING: in checked list:" $listVar 1>&2
231          testoutput_for_prop $1 "dynstat_vvel_mean" "V mean" $2 $3; vmean=$?          #- put it back once:
232          testoutput_for_prop $1 "dynstat_vvel_sd" "V s.d." $2 $3; vsd=$?            listVar=" $sVar "`echo "$listVar " | sed "s/ $sVar / /g"`
233            fi
234          #  This is for PTRACERS          if [ $debug -gt 0 ]; then echo "testoutput_run: listVar(M)='$listVar'" 1>&2 ; fi
235          for ii in $PTRACERS_NUM ; do          echo "listVar='$listVar'" > $CDIR"/summary.txt"
236              eval `echo "p0"$ii"_min=99"`          allargs=""
237              eval `echo "p0"$ii"_max=99"`          for xx in $listVar
238              eval `echo "p0"$ii"_mean=99"`          do
239              eval `echo "p0"$ii"_sd=99"`            case $xx in
240              tst=`eval 'echo "$HAVE_PTR0'$ii'"'`             'PS')  if [ $debug -gt 0 ]
241              #echo 'tst = '$tst                    then echo testoutput_run: testoutput_var $1 cg2d_init_res 1>&2 ; fi
242              if test "x$tst" = xt ; then                    testoutput_var $1 "cg2d_init_res" "Press. Solver (cg2d)" $2 $3; yy=$?
243                  a="trcstat_ptracer0"                    if [ $debug -gt 0 ] ; then echo testoutput_run: cg2dres=$yy 1>&2 ; fi ;;
244                  testoutput_for_prop $1 "$a"$ii"_min"  "p0"$ii"_min"  $2 $3            'Cost') testoutput_var $1 "ADM  precision_derivative_cost" "ADM Cost" $2 $3; yy=$? ;;
245                  RETVAL=$? ; eval `echo "p0"$ii"_min="$RETVAL`            'Grad') testoutput_var $1 "ADM  precision_derivative_grad" "ADM Grad" $2 $3; yy=$? ;;
246                  testoutput_for_prop $1 "$a"$ii"_max"  "p0"$ii"_max"  $2 $3             'Tmn') testoutput_var $1 "dynstat_theta_min"  "Theta minimum"  $2 $3; yy=$? ;;
247                  RETVAL=$? ; eval `echo "p0"$ii"_max="$RETVAL`             'Tmx') testoutput_var $1 "dynstat_theta_max"  "Theta maximum"  $2 $3; yy=$? ;;
248                  testoutput_for_prop $1 "$a"$ii"_mean" "p0"$ii"_mean" $2 $3             'Tav') testoutput_var $1 "dynstat_theta_mean" "Theta mean"     $2 $3; yy=$? ;;
249                  RETVAL=$? ; eval `echo "p0"$ii"_mean="$RETVAL`             'Tsd') testoutput_var $1 "dynstat_theta_sd"   "Theta Std.Dev"  $2 $3; yy=$? ;;
250                  testoutput_for_prop $1 "$a"$ii"_sd"   "p0"$ii"_sd"   $2 $3             'Smn') testoutput_var $1 "dynstat_salt_min"  "Salt minimum"    $2 $3; yy=$? ;;
251                  RETVAL=$? ; eval `echo "p0"$ii"_sd="$RETVAL`             'Smx') testoutput_var $1 "dynstat_salt_max"  "Salt maximum"    $2 $3; yy=$? ;;
252              fi             'Sav') testoutput_var $1 "dynstat_salt_mean" "Salt mean"       $2 $3; yy=$? ;;
253          done             'Ssd') testoutput_var $1 "dynstat_salt_sd"   "Salt Std.Dev"    $2 $3; yy=$? ;;
254               'Umn') testoutput_var $1 "dynstat_uvel_min"  "U minimum"       $2 $3; yy=$? ;;
255          allargs="$cg2dres $tmin $tmax $tmean $tsd $smin $smax $smean $ssd"             'Umx') testoutput_var $1 "dynstat_uvel_max"  "U maximum"       $2 $3; yy=$? ;;
256          allargs="$allargs $umin $umax $umean $usd $vmin $vmax $vmean $vsd"             'Uav') testoutput_var $1 "dynstat_uvel_mean" "U mean"          $2 $3; yy=$? ;;
257          allargs="$allargs $p01_min $p01_max $p01_mean $p01_sd"             'Usd') testoutput_var $1 "dynstat_uvel_sd"   "U Std.Dev"       $2 $3; yy=$? ;;
258          allargs="$allargs $p02_min $p02_max $p02_mean $p02_sd"             'Vmn') testoutput_var $1 "dynstat_vvel_min"  "V minimum"       $2 $3; yy=$? ;;
259          allargs="$allargs $p03_min $p03_max $p03_mean $p03_sd"             'Vmx') testoutput_var $1 "dynstat_vvel_max"  "V maximum"       $2 $3; yy=$? ;;
260          allargs="$allargs $p04_min $p04_max $p04_mean $p04_sd"             'Vav') testoutput_var $1 "dynstat_vvel_mean" "V mean"          $2 $3; yy=$? ;;
261          allargs="$allargs $p05_min $p05_max $p05_mean $p05_sd"             'Vsd') testoutput_var $1 "dynstat_vvel_sd"   "V Std.Dev"       $2 $3; yy=$? ;;
262            'pt1mn'|'pt2mn'|'pt3mn'|'pt4mn'|'pt5mn') ii=`echo $xx | sed 's/pt//' | sed 's/..$//'`
263          eval "dashnum $allargs"             testoutput_var $1 "trcstat_ptracer0"$ii"_min"  "p0"$ii"_min"   $2 $3; yy=$? ;;
264            'pt1mx'|'pt2mx'|'pt3mx'|'pt4mx'|'pt5mx') ii=`echo $xx | sed 's/pt//' | sed 's/..$//'`
265      else             testoutput_var $1 "trcstat_ptracer0"$ii"_max"  "p0"$ii"_max"   $2 $3; yy=$? ;;
266          testoutput_ad $1 $2 "precision_grdchk_result"          'pt1av'|'pt2av'|'pt3av'|'pt4av'|'pt5av') ii=`echo $xx | sed 's/pt//' | sed 's/..$//'`
267      fi             testoutput_var $1 "trcstat_ptracer0"$ii"_mean" "p0"$ii"_mean" $2 $3; yy=$? ;;
268            'pt1sd'|'pt2sd'|'pt3sd'|'pt4sd'|'pt5sd') ii=`echo $xx | sed 's/pt//' | sed 's/..$//'`
269               testoutput_var $1 "trcstat_ptracer0"$ii"_sd"   "p0"$ii"_StDv"  $2 $3; yy=$? ;;
270             'Qntmn') testoutput_var $1 "extforcing_qnet_min" "Qnet minimum"  $2 $3; yy=$? ;;
271             'Qntmx') testoutput_var $1 "extforcing_qnet_max" "Qnet maximum"  $2 $3; yy=$? ;;
272             'Qntav') testoutput_var $1 "extforcing_qnet_mean" "Qnet mean"    $2 $3; yy=$? ;;
273             'Qntsd') testoutput_var $1 "extforcing_qnet_sd"  "Qnet Std.Dev"  $2 $3; yy=$? ;;
274             'aSImn') testoutput_var $1 "seaice_area_min"   "SIce Area min"   $2 $3; yy=$? ;;
275             'aSImx') testoutput_var $1 "seaice_area_max"   "SIce Area max"   $2 $3; yy=$? ;;
276             'aSIav') testoutput_var $1 "seaice_area_mean"  "SIce Area mean"  $2 $3; yy=$? ;;
277             'aSIsd') testoutput_var $1 "seaice_area_sd"    "SIce Area StDv"  $2 $3; yy=$? ;;
278             'hSImn') testoutput_var $1 "seaice_heff_min"   "SIce Heff min"   $2 $3; yy=$? ;;
279             'hSImx') testoutput_var $1 "seaice_heff_max"   "SIce Hell max"   $2 $3; yy=$? ;;
280             'hSIav') testoutput_var $1 "seaice_heff_mean"  "SIce Hell mean"  $2 $3; yy=$? ;;
281             'hSIsd') testoutput_var $1 "seaice_heff_sd"    "SIce Hell StDv"  $2 $3; yy=$? ;;
282            'AthSiG') testoutput_var $1 "thSI_Ice_Area_G" "thSIc Area Global" $2 $3; yy=$? ;;
283            'AthSiS') testoutput_var $1 "thSI_Ice_Area_S" "thSIc Area South"  $2 $3; yy=$? ;;
284            'AthSiN') testoutput_var $1 "thSI_Ice_Area_N" "thSIc Area North"  $2 $3; yy=$? ;;
285            'HthSiG') testoutput_var $1 "thSI_IceH_ave_G" "thSIc H Global"    $2 $3; yy=$? ;;
286            'HthSiS') testoutput_var $1 "thSI_IceH_ave_S" "thSIc H South"     $2 $3; yy=$? ;;
287            'HthSiN') testoutput_var $1 "thSI_IceH_ave_N" "thSIc H North"     $2 $3; yy=$? ;;
288                  *) yy=99; echo "WARNING: asking for var=$xx : not recognized !" 1>&2 ;;
289              esac
290              if test $xx = $sVar
291              then allargs="$allargs > $yy <"
292              else allargs="$allargs $yy"
293              fi
294            done
295    
296            nbVar=`echo $listVar | awk '{print NF}'`
297            if [ $nbVar -lt $LEN_CHECK_LIST ] ; then
298            #-- fill line (up to standard length) with dot:
299              adNul=`expr $LEN_CHECK_LIST - $nbVar | awk '{for(i=1;i<=$1;i++){print "."}}'`
300              echo $allargs $adNul
301            else
302              echo $allargs
303            fi
304    # <-- same processing for adjoint & forward test
305  }  }
306    
307  genmakemodel()  genmakemodel()
# Line 304  genmakemodel() Line 322  genmakemodel()
322                  command="$command --mods=../code"                  command="$command --mods=../code"
323              else              else
324                  command="$command --mods=../code_ad"                  command="$command --mods=../code_ad"
                 command="$command -adof=../../../tools/adjoint_options/adjoint_staf"  
325              fi              fi
326              if test "x$OPTFILE" != xNONE ; then              if test "x$OPTFILE" != xNONE ; then
327                  command="$command --optfile=$OPTFILE"                  command="$command --optfile=$OPTFILE"
# Line 312  genmakemodel() Line 329  genmakemodel()
329              if test "x$IEEE" != x ; then              if test "x$IEEE" != x ; then
330                  command="$command -ieee"                  command="$command -ieee"
331              fi              fi
332                if test "x$GSL" = xt ; then
333                    command="$command -gsl"
334                fi
335              if test "x$MPI" = xt ; then              if test "x$MPI" = xt ; then
336                  command="$command -mpi"                  command="$command -mpi"
337              fi              fi
338                if test "x$TS" = xt ; then
339                    command="$command -ts"
340                fi
341                if test "x$PAPIS" = xt ; then
342                    command="$command -papis"
343                else
344                if test "x$PCLS" = xt ; then
345                    command="$command -pcls"
346                fi
347                fi
348              printf 'genmake ... ' 1>&2              printf 'genmake ... ' 1>&2
349              $command > make.log 2>&1              $command > make.log 2>&1
350              RETVAL=$?              RETVAL=$?
# Line 336  makeclean() Line 366  makeclean()
366  {  {
367      # makeclean directory      # makeclean directory
368      if test "x$NOCLEAN" = xt ; then      if test "x$NOCLEAN" = xt ; then
369          echo "make CLEAN skipped!"          echo "make Clean skipped!"
370      else      else
371          (          (
372              cd $1;              cd $1;
373              if test -e output.txt ; then              #if test -e $OUTPUTFILE ; then rm -f $OUTPUTFILE ; fi
                 rm -f output.txt  
             fi  
             printf 'make CLEAN ... ' 2>&1  
374              if test -r Makefile ; then              if test -r Makefile ; then
375                  $MAKE CLEAN >> make.log 2>&1                  printf 'clean build-dir: make Clean ... ' 2>&1
376                    $MAKE Clean >> make.log 2>&1
377                  RETVAL=$?                  RETVAL=$?
378                  if test "x$RETVAL" != x0 ; then                  if test "x$RETVAL" != x0 ; then
379                      tail make.log                      tail make.log
380                      echo "makeclean: \"make CLEAN\" failed" 1>&2                      echo "makeclean: \"make Clean\" failed" 1>&2
381                      cp make.log $CDIR"/make.log"                      cp make.log $CDIR"/make.log"
382                      return 1                      return 1
383                  fi                  fi
# Line 360  makeclean() Line 388  makeclean()
388      fi      fi
389  }  }
390    
391  postclean()  run_clean()
392  {  {
393      # postclean directory      # run_clean directory
394      if test "x$POSTCLEAN" = xt ; then      if test "x$NOCLEAN" = xt ; then
395            echo "run_clean skipped!"
396        else
397          (          (
398              cd $1;              cd $1;
399              if test -r Makefile ; then              printf 'clean run-dir ... ' 2>&1
400                  $MAKE CLEAN >> /dev/null 2>&1              # part of what is done after "make clean" when doing "make CLEAN"
401              fi              find . -name "*.meta" -exec rm {} \;
402                find . -name "*.data" -exec rm {} \;
403                find . -name "fort.*" -exec rm {} \;
404                find . -type l -exec rm {} \;
405                rm -f $EXECUTABLE *.txt STD* *diagnostics.log datetime
406                rm -rf mnc_test_*
407                rm -f *_MIT_CE_000.opt0000 costfunction*0000
408                echo successful 1>&2
409              exit 0              exit 0
410          )          )
411      fi      fi
# Line 438  symlink_mpifiles() Line 475  symlink_mpifiles()
475      CODE_DIR=$dir/$code_dir      CODE_DIR=$dir/$code_dir
476            
477      # These are files that should replace their counter-part when using -mpi      # These are files that should replace their counter-part when using -mpi
478      MPI_FILES=`(cd $CODE_DIR; find . -name "*_mpi")`      MPI_FILES=`(cd $CODE_DIR; find . -name "*_mpi" -print)`
479    
480      #  Is this an MPI run?      #  Is this an MPI run?
481      if test "x$MPI" = xt ; then      if test "x$MPI" = xt ; then
# Line 476  symlink_mpifiles() Line 513  symlink_mpifiles()
513    
514  linkdata()  linkdata()
515  {  {
516      # linkdata flag      # linkdata run_dir input_dir_1 input_dir_2 ...
517      #      #
518      # symbolically link data files to run directory      # symbolically link data files to run directory
519      if test "x$1" = x1 ; then      if test -d $1 ; then
520          (          (
521              cd $2              cd $1 ; shift
522              if test "x$ADM" = x ; then              if test -r "../"$1"/eedata.mth" ; then
523                  files=`( cd ../input ; ls -1 | grep -v CVS )`              # found eedata.mth in 1rst input dir and it is readable
524                  for i in $files ; do                  if test "x$MULTI_THREAD" = "xt" ; then
525                      if test ! -d "../input/"$i -a ! -f $i ; then                  # multi-threaded test: remove symbolic link & link eedata.mth
526                          ln -sf "../input/"$i $i                      if test -h eedata ; then rm -f eedata ; fi
527                      fi                      if test ! -r eedata ; then
528                  done                          ln -sf "../"$1"/eedata.mth" eedata ;
529              else                          printf 'eedata.mth ' 1>&2
                 files=`( cd ../input ; ls -1 *.bin | grep -v CVS )`  
                 for i in $files ; do  
                     if test ! -d "../input/"$i ; then  
                         ln -sf "../input/"$i $i  
530                      fi                      fi
531                  done                  else
532                  files=`( cd ../input_ad ; ls -1 | grep -v CVS )`                  # not multi-threaded test: remove eedata symbolic link
533                  for i in $files ; do                      if test -h eedata ; then rm -f eedata ; fi
534                      if test ! -d "../input_ad/"$i ; then                  fi
                         ln -sf "../input_ad/"$i $i  
                     fi  
                 done  
535              fi              fi
536                prevDir='NONE'
537                for ldir in $* ; do
538                    if test -d "../"$ldir -a $ldir != $prevDir ; then
539                        printf 'ldir='${ldir} 1>&2
540                        files=`( cd "../"$ldir ; ls -1 | grep -v CVS )`
541                        for i in $files ; do
542                            if test ! -d "../"$ldir/$i ; then
543                                if test ! -r $i  ; then
544                                    printf ' '$i 1>&2
545                                    ln -sf "../"$ldir"/"$i $i
546                                fi
547                            fi
548                        done
549                        if test -x "../"$ldir"/"prepare_run ; then
550                            "../"$ldir"/"prepare_run
551                        fi
552                        printf ' ; ' 1>&2
553                    fi
554                    prevDir=$ldir
555                done
556          )          )
557      fi      fi
558  }  }
# Line 518  runmodel() Line 568  runmodel()
568          printf 'runmodel in %s ...' $1 1>&2          printf 'runmodel in %s ...' $1 1>&2
569          # make output.txt          # make output.txt
570          echo          echo
571          rm -f run.log          if test -L $EXECUTABLE -a -x "../"$builddir"/"$EXECUTABLE ; then
572          if test $OUTPUTFILE -ot $EXECUTABLE ; then              diff -q $EXECUTABLE "../"$builddir"/"$EXECUTABLE > /dev/null 2>&1
573             ( eval $COMMAND ) > run.log 2>&1              outD=$? ; if test $outD != 0 ; then rm -f $EXECUTABLE ; rm -f run.log ; fi
574             RETVAL=$?          fi
575            if test ! -x $EXECUTABLE -a -x "../"$builddir"/"$EXECUTABLE ; then
576                echo " link" $EXECUTABLE "from dir ../"$builddir > run.log_00
577                ln -sf "../"$builddir"/"$EXECUTABLE .
578            fi
579            if test ! -x $EXECUTABLE ; then
580                    rm -f run.log ; touch run.log
581                    if test -f run.log_00 ; then cat run.log_00 >> run.log ; fi
582                    echo " no executable:" $EXECUTABLE >> run.log
583                    RETVAL=8
584                    ENDVAL=-1
585          else          else
586             echo " $OUTPUTFILE is up to date " > run.log 2>&1              if test ! -f $OUTPUTFILE -o $OUTPUTFILE -ot $EXECUTABLE ; then
587             RETVAL=0                # output do not exist or is older than executable:
588                    rm -f run.log ; touch run.log
589                    if test -f run.log_00 ; then cat run.log_00 >> run.log ; fi
590                    ( eval $COMMAND ) >> run.log 2>&1
591                    RETVAL=$?
592                else
593                    RETVAL=0
594                    if test -f run.log ; then
595                        if test -f run.log_00 ; then cat run.log_00 >> run.log ; fi
596                        echo "---------->> $OUTPUTFILE is up to date " >> run.log 2>&1
597                    else
598                        touch run.log
599                        if test -f run.log_00 ; then cat run.log_00 >> run.log ; fi
600                        echo "---------->> $OUTPUTFILE is up to date " >> run.log 2>&1
601                        echo " no previous run.log: assume NORMAL END" >> run.log 2>&1
602                    fi
603                fi
604                ENDVAL=`cat run.log | grep -v 'ABNORMAL END' | grep -c 'NORMAL END'`
605          fi          fi
606          # echo "COMMAND='$COMMAND'"          rm -f run.log_00
607          # echo "pwd='"`pwd`"'"          #if test "x$RETVAL" = x0 ; then
608          if test "x$RETVAL" = x0 ; then          if [ $RETVAL -eq 0 -a $ENDVAL -gt 0 ] ; then
609              tail run.log              tail run.log
610              echo successful 1>&2              echo successful 1>&2
611              # === Reduce the size of the testing emails!              # === Reduce the size of the testing emails!
612              # if test "x$ADM" = x ; then              #cp $OUTPUTFILE $CDIR"/"$OUTPUTFILE
             #   cp output.txt $CDIR"/output.txt"  
             # else  
             #   cp output.txt_adm $CDIR"/output.txt_adm"  
             # fi  
613              if test -s STDERR.0000 ; then cp STDERR.0000 $CDIR"/STDERR.0000" ; fi              if test -s STDERR.0000 ; then cp STDERR.0000 $CDIR"/STDERR.0000" ; fi
614              return 0              return 0
615          else          else
616              tail run.log              tail run.log
617              echo failed 1>&2              echo failed '(run:' $RETVAL ' end:' $ENDVAL ')' 1>&2
618              cp run.log $CDIR"/run.log"              cp run.log $CDIR"/run.log"
619              if test -s STDERR.0000 ; then cp STDERR.0000 $CDIR"/STDERR.0000" ; fi              if test -s STDERR.0000 ; then cp STDERR.0000 $CDIR"/STDERR.0000" ; fi
620              return 1              return 1
# Line 553  createcodelet() Line 626  createcodelet()
626  {  {
627      # create codelet for comparing model output      # create codelet for comparing model output
628    
629      printf "creating the comparison code...  "      printf "creating the comparison code (using CC=$CC)...  "
630      cat > tmp_cmpnum.c <<EOF      cat > tr_cmpnum.c <<EOF
631  #include <stdio.h>  #include <stdio.h>
632  #include <math.h>  #include <math.h>
633  int main( int argc, char** argv )  {  int main( int argc, char** argv )  {
634    int linnum,best,lncnt;    int linnum,cmplin,best,lncnt;
635    double a,b,abave,relerr;    double a,b,abave,relerr;
636    best = -22;    best = -22;
637    lncnt = 0;    lncnt = 0;
638    while( 1 & (lncnt+=1) < 999 )  {    while( 1 & ( (lncnt+=1) < 999 ) )  {
639      scanf("%d", &linnum);      scanf("%d", &linnum);
640      if (linnum == -1)  break;      if (linnum == -1)  break;
641      scanf("%lf", &a);  scanf("%lf", &b);      scanf("%lf", &a);  scanf("%lf", &b);
642      abave = 0.5*(fabs(a)+fabs(b));      abave = 0.5*(fabs(a)+fabs(b));
643      if (abave > 0.0) {      if ( abave == abave ) {
644        relerr=fabs(a-b)/abave;        if (abave > 0.0) {
645        if (relerr > 0.0) { linnum = (int)rint(log10(relerr)); }          relerr=fabs(a-b)/abave;
646        else { linnum = -16 ; }          if (relerr > 0.0) { cmplin = (int)rint(log10(relerr)); }
647        best = (best > linnum) ? best : linnum;          else { cmplin = -16 ; }
648      }          best = (best > cmplin) ? best : cmplin; }
649          else { cmplin = -22 ; }
650       /* printf("%d ; %lf ; %lf\n",cmplin,a,b); */
651          }
652       else {
653       /* printf("%lf ; %lf ; %lf\n",abave,a,b); */
654          break; }
655    }    }
656    if (lncnt == 999) best=-29;    if (lncnt == 999) best=-29;
657      if (linnum != -1) best=-99;
658    printf("%d\n", -best);    printf("%d\n", -best);
659    return 0;    return 0;
660  }  }
661  EOF  EOF
662      $CC -o tmp_cmpnum tmp_cmpnum.c -lm      $CC -o tr_cmpnum tr_cmpnum.c -lm
663    
664      if [ -x ./tmp_cmpnum ]; then      if [ -x ./tr_cmpnum ]; then
665          echo "OK"          echo "OK"
666          return 0          return 0
667      else      else
# Line 599  formatresults() Line 679  formatresults()
679      nm=$1      nm=$1
680      printf '%s %s %s %s' $2 $3 $4 $5      printf '%s %s %s %s' $2 $3 $4 $5
681      shift; shift; shift; shift; shift;      shift; shift; shift; shift; shift;
682      printf '%3s' $@      listPrt=$@
683        listRes=`echo $listPrt | sed 's/>//' | sed 's/<//'`
684        xx=`echo $listPrt | sed 's/.*>//' | sed 's/<.*//' | awk '{print $1}'`
685        printf '%3s' $listPrt
686    #   line below does not work on hp-ux_ia64 : do those substitutions later on
687    #   printf '%3s' $listPrt | sed 's/ 99/ --/g' | sed 's/  > />/' | sed 's/  < /</'
688            
689      if [ $1 = '--' ]; then      if [ $xx = '..' ]; then
690            printf ' N/O '
691        elif [ $xx = '--' ]; then
692            printf ' N/O '
693        elif [ $xx = 99 ]; then
694          printf ' N/O '          printf ' N/O '
695      else      else
696          if [ $1 -gt 12 ]; then          if [ $xx -ge $MATCH_CRIT ]; then
697              printf ' pass'              printf ' pass'
698          else          else
699              printf ' FAIL'              printf ' FAIL'
# Line 615  formatresults() Line 704  formatresults()
704            
705  }  }
706    
 show_help()  
 {  
     cat - << EOF  
 $0 [-help] [-quick] [-verbose] dir1 [dir2] [...]  
   
  -help|-h      Show this help message  
  -quiet     Reduce the amount of output  
  -verbose   Produce copious amounts of output  
  -debug     Produce even more output which will mean nothing to most  
  -force     Do "make CLEAN" before compiling. This forces a complete rebuild.  
  -clean     Do "make CLEAN" after compiling and testing.  
  -cleanup   Aggresively removes all model output, executables and object files  
             and then exits. Use with care.  
   
 Normal usage:  
  $0 *       Configure, compile, run and analyze in all experiment directories  
 EOF  
 }  
   
707  scandirs()  scandirs()
708  {  {
709      if [ $# -eq 0 ]; then      if [ $# -eq 1 ]; then
710          for arg in * ; do          for arg in * ; do
711              test -d $arg/input && echo $arg              test -f $arg/$1 && echo $arg
712          done          done
713      else      else
714          echo $*          echo $*
715      fi      fi
716  }  }
717    
# Line 653  scandirs() Line 723  scandirs()
723  debug=0  debug=0
724  verbose=1  verbose=1
725  clean=0  clean=0
 expts=''  
 # ieee=1  
726    
727  IEEE=true  IEEE=true
728  if test "x$MITGCM_IEEE" != x ; then  if test "x$MITGCM_IEEE" != x ; then
729      IEEE=$MITGCM_IEEE      IEEE=$MITGCM_IEEE
730  fi  fi
731    GSL=f
732    
733  CLEANUP=f  CLEANUP=f
734  QUICK=f  QUICK=f
# Line 673  BASH= Line 741  BASH=
741  OPTFILE=NONE  OPTFILE=NONE
742  ADDRESSES=  ADDRESSES=
743  TESTDIRS=  TESTDIRS=
744    SKIPDIRS=
745  MPACKDIR="../tools/mpack-1.6"  MPACKDIR="../tools/mpack-1.6"
746  HAVE_MPACK=  HAVE_MPACK=
747  MPACK="$MPACKDIR/mpack"  MPACK="$MPACKDIR/mpack"
# Line 685  if test "x$CC" = x ; then Line 754  if test "x$CC" = x ; then
754  fi  fi
755  JOBS=  JOBS=
756  MPI=f  MPI=f
757    MULTI_THREAD=f
758  OUTDIR=  OUTDIR=
759  DELDIR=  DELDIR=
760    
# Line 693  ADM= Line 763  ADM=
763  # Additional monitor types  # Additional monitor types
764  PTRACERS_NUM="1 2 3 4 5"  PTRACERS_NUM="1 2 3 4 5"
765    
766    MATCH_CRIT=13
767    
768  printf "parsing options...  "  printf "parsing options...  "
769    
770  ac_prev=  ac_prev=
# Line 727  for ac_option ; do Line 799  for ac_option ; do
799          -tdir=* | --tdir=*)          -tdir=* | --tdir=*)
800              TESTDIRS=$ac_optarg ;;              TESTDIRS=$ac_optarg ;;
801    
802            -skipdir | --skipdir | -skd | --skd)
803                ac_prev=SKIPDIRS ;;
804            -skipdir=* | --skipdir=*)
805                SKIPDIRS=$ac_optarg ;;
806    
807          -bash | --bash | -b | --b)          -bash | --bash | -b | --b)
808              ac_prev=BASH ;;              ac_prev=BASH ;;
809          -bash=* | --bash=*)          -bash=* | --bash=*)
# Line 752  for ac_option ; do Line 829  for ac_option ; do
829          -ptracers=* | --ptracers=* | -ptr=* | --ptr=*)          -ptracers=* | --ptracers=* | -ptr=* | --ptr=*)
830              PTRACERS_NUM=$ac_optarg ;;              PTRACERS_NUM=$ac_optarg ;;
831    
832            -match | --match ) ac_prev=MATCH_CRIT ;;
833            -match=* | --match=* ) MATCH_CRIT=$ac_optarg ;;
834    
835          -j) ac_prev=JOBS ;;          -j) ac_prev=JOBS ;;
836          -j=*) JOBS=$ac_optarg ;;          -j=*) JOBS=$ac_optarg ;;
837    
# Line 772  for ac_option ; do Line 852  for ac_option ; do
852    
853          -mpi) MPI=t ;;          -mpi) MPI=t ;;
854    
855            -mth) MULTI_THREAD=t ;;
856    
857          -adm | -ad) ADM=t ;;          -adm | -ad) ADM=t ;;
858    
859          -ieee) IEEE=true ;;          -ieee) IEEE=true ;;
860          -noieee) IEEE= ;;          -noieee) IEEE= ;;
861            -gsl) GSL=t ;;
862    
863          -verbose) verbose=2 ;;          -verbose) verbose=2 ;;
864          -debug) debug=1 ;;          -debug) debug=1 ;;
# Line 783  for ac_option ; do Line 866  for ac_option ; do
866    
867          -deldir | -dd) DELDIR=t ;;          -deldir | -dd) DELDIR=t ;;
868    
869            -ts) TS=t;;
870    
871            -papis) PAPIS=t;;
872    
873            -pcls) PCL=t;;
874    
875          -*)          -*)
876              echo "Error: unrecognized option: "$ac_option              echo "Error: unrecognized option: "$ac_option
877              usage              usage
# Line 803  if test "x$QUICK" = xt ; then Line 892  if test "x$QUICK" = xt ; then
892      NODEPEND=t      NODEPEND=t
893  fi  fi
894    
895  if test "x$TESTDIRS" = x ; then  #- setting for forward or ADM testing
     TESTDIRS=`scandirs`  
 fi  
   
 if test "x$OPTFILE" = xNONE -a "x$MITGCM_OF" != x ; then  
     OPTFILE=$MITGCM_OF  
 fi  
   
896  if test "x$ADM" = xt ; then  if test "x$ADM" = xt ; then
897        code_dir=code_ad
898        inputdir=input_ad
899        ref_outp="output_adm.txt"
900      EXECUTABLE="mitgcmuv_ad"      EXECUTABLE="mitgcmuv_ad"
     OUTPUTFILE="output.txt_adm"  
901  else  else
902        code_dir=code
903        inputdir=input
904        ref_outp="output.txt"
905      EXECUTABLE="mitgcmuv"      EXECUTABLE="mitgcmuv"
     OUTPUTFILE="output.txt"  
906  fi  fi
907    
908  if test "x$ADM" = xt -a "x$COMMAND" = x ; then  if test "x$TESTDIRS" = x ; then
909      COMMAND="./$EXECUTABLE > $OUTPUTFILE"      LIST=`scandirs results/$ref_outp`
910    else
911        #- expand group of experiments:
912        LIST=" "
913        for xx in $TESTDIRS
914        do
915          case $xx in
916            'basic') LIST=${LIST}" aim.5l_cs hs94.128x64x5 ideal_2D_oce"
917                     LIST=${LIST}" lab_sea tutorial_baroclinic_gyre"
918                     LIST=${LIST}" tutorial_global_oce_latlon tutorial_plume_on_slope"
919                    ;;
920            'tutorials')
921                     LIST=${LIST}" "`ls | grep 'tutorial_'` ;;
922            *)       LIST=${LIST}" "$xx ;;
923          esac
924        done
925    fi
926    #echo 'LIST='${LIST}'<'
927    #- skip dirs, remove duplicate and non-directory:
928    TESTDIRS=" "
929    count=0
930    for xx in $LIST
931    do
932        yy=`echo $SKIPDIRS | grep -c $xx`
933        if test $yy = 0 ; then
934            if test -d $xx ; then
935                yy=`echo $TESTDIRS | grep -c $xx`
936                if test $yy = 0 ; then TESTDIRS=${TESTDIRS}" "$xx ; fi
937            else count=1 ;
938                echo ""; echo -n " -- skip \"$xx\" (not a directory !)"
939            fi
940        else
941            if test $count = 1 ; then echo -n ", \"$xx\""
942            else count=1 ; echo "" ;  echo -n " skip: \"$xx\""
943            fi
944        fi
945    done
946    if test $count = 1 ; then echo "" ; echo -n " ... " ; fi
947    #echo 'TESTDIRS='${TESTDIRS}'<'
948    
949    if test "x$OPTFILE" = xNONE -a "x$MITGCM_OF" != x ; then
950        OPTFILE=$MITGCM_OF
951  fi  fi
952    
953    OUTPUTFILE=$ref_outp
954  if test "x$COMMAND" = x ; then  if test "x$COMMAND" = x ; then
955      COMMAND="./$EXECUTABLE > $OUTPUTFILE"      COMMAND="./$EXECUTABLE > $OUTPUTFILE"
956  fi  fi
957    if test "x$MPI" = xt ; then
958        OUTPUTFILE="STDOUT.0000"
959    fi
960    
 #echo "OK"  
961  echo "OK (COMMAND= $COMMAND )"  echo "OK (COMMAND= $COMMAND )"
962    
963    # set the Default List of output variables to be checked:
964    #  (use default or load experiment-specific list from file "tr_checklist")
965    # content : 1rst = main variable used to decide if it pass or FAIL
966    #         others = number of matching digits to be printed in summary.txt
967    if test "x$ADM" = x ; then
968        DEF_CHECK_LIST='PS PS T+ S+ U+ V+ pt1+ pt2+ pt3+ pt4+ pt5+'
969        EMPTY_RESULTS='.. .. .. .. .. .. .. .. .. .. .. .. .. .. .. .. ..'
970        LEN_CHECK_LIST=`echo $DEF_CHECK_LIST | sed 's/ [a-zA-Z0-9]*+/&mn &mx &av &sd/g' | awk '{print NF-1}'`
971        ii=`echo $EMPTY_RESULTS | awk '{print NF}'`
972        EMPTY_RESULTS=$EMPTY_RESULTS`expr $LEN_CHECK_LIST - $ii | awk 'BEGIN{FS=":"}{for(i=1;i<=$1;i++){printf "  ."}}'`
973    else
974        DEF_CHECK_LIST='Grad Cost Grad'
975        EMPTY_RESULTS='.. ..'
976        LEN_CHECK_LIST=`echo $DEF_CHECK_LIST | sed 's/ [a-zA-Z0-9]*+/&mn &mx &av &sd/g' | awk '{print NF-1}'`
977    fi
978    
979  #  create the FORTRAN comparison code  #  create the FORTRAN comparison code
980  createcodelet  createcodelet
981    
982  #  build the mpack utility  #  build the mpack utility (if ADDRESSES = NONE, do it to test the build)
983  if test "x$ADDRESSES" = xNONE -o "x$ADDRESSES" = x ; then  if test "x$ADDRESSES" = x ; then
984      echo "skipping mpack build"      echo "skipping mpack build"
985  else  else
986      build_mpack      build_mpack
987  fi  fi
988    
989  #  Create a uniquely named directory to store results  #  Create a uniquely named directory to store results
990    CMDLINE=$0
991    for xx in "$@" ; do CMDLINE="$CMDLINE '$xx'" ; done
992  MACH=`hostname`  MACH=`hostname`
993  UNAMEA=`uname -a`  UNAMEA=`uname -a`
994  DATE=`date +%Y%m%d`  DATE=`date +%Y%m%d`
# Line 861  if test "x$RETVAL" != x0 ; then Line 1009  if test "x$RETVAL" != x0 ; then
1009      exit 1      exit 1
1010  fi  fi
1011  SUMMARY="$DRESULTS/summary.txt"  SUMMARY="$DRESULTS/summary.txt"
 printf "Start time:  " >> $SUMMARY  
1012  start_date=`date`  start_date=`date`
1013  echo $start_date > $SUMMARY  echo $start_date > $SUMMARY
1014    echo 'run:' $CMDLINE >> $SUMMARY
1015    echo 'on :' $UNAMEA  >> $SUMMARY
1016    
1017  of_path=  of_path=
1018  if test "x$OPTFILE" != xNONE ; then  if test "x$OPTFILE" != xNONE ; then
# Line 893  fi Line 1042  fi
1042  echo  echo
1043  echo >> $SUMMARY  echo >> $SUMMARY
1044  if test "x$ADM" = x ; then  if test "x$ADM" = x ; then
1045      line_0="            ----T-----  ----S-----  ----U-----  ----V-----"      if [ $MATCH_CRIT -lt 10 ] ;
1046        then line_0="default  "$MATCH_CRIT ;
1047        else line_0="default "$MATCH_CRIT ; fi
1048           line_0="$line_0  ----T-----  ----S-----  ----U-----  ----V-----"
1049    #   line_0="            ----T-----  ----S-----  ----U-----  ----V-----"
1050      line_1="G D M    c        m  s        m  s        m  s        m  s"      line_1="G D M    c        m  s        m  s        m  s        m  s"
1051      line_2="E p a R  g  m  m  e  .  m  m  e  .  m  m  e  .  m  m  e  ."      line_2="E p a R  g  m  m  e  .  m  m  e  .  m  m  e  .  m  m  e  ."
1052      line_3="N n k u  2  i  a  a  d  i  a  a  d  i  a  a  d  i  a  a  d"      line_3="N n k u  2  i  a  a  d  i  a  a  d  i  a  a  d  i  a  a  d"
# Line 917  if test "x$ADM" = x ; then Line 1070  if test "x$ADM" = x ; then
1070  else  else
1071      echo "ADJOINT=true" >> $SUMMARY      echo "ADJOINT=true" >> $SUMMARY
1072      echo >> $SUMMARY      echo >> $SUMMARY
1073        if [ $MATCH_CRIT -lt 10 ] ;
1074        then line_0="default     "$MATCH_CRIT ;
1075        else line_0="default    "$MATCH_CRIT ; fi
1076        echo "$line_0" | tee -a $SUMMARY
1077      cat << EOF | tee -a $SUMMARY      cat << EOF | tee -a $SUMMARY
1078  G D M    C  G  G D M    C  G
1079  E p a R  o  r  E p a R  o  r
# Line 929  fi Line 1086  fi
1086  #  ...and each test directory...  #  ...and each test directory...
1087  for dir in $TESTDIRS ; do  for dir in $TESTDIRS ; do
1088            
1089        # set builddir & rundir:
1090        builddir="build"
1091        if test ! -d $dir/$builddir ; then mkdir $dir/$builddir ; fi
1092        rundir="run"
1093        if test ! -d $dir/$rundir ; then
1094            rundir=$builddir
1095        fi
1096        CODE_DIR=$dir/$code_dir
1097        BUILD_DIR=$dir/$builddir
1098    
1099      #  Cleanup only!      #  Cleanup only!
1100      if test "x$CLEANUP" = xt ; then      if test "x$CLEANUP" = xt ; then
1101          if test -r $dir/build/Makefile ; then          if test -r $BUILD_DIR/Makefile ; then
1102              ( cd $dir/build ; make CLEAN )              echo '  ------  clean dir:' $dir/build
1103                ( cd $BUILD_DIR ; make CLEAN )
1104          fi          fi
1105          if test -r $dir/input/Makefile ; then          if test -d $dir/$rundir/CVS ; then
1106              ( cd $dir/input ; make CLEAN )              echo '  ------  clean dir:' $dir/$rundir
1107                run_clean $dir/$rundir
1108          fi          fi
1109          (          (
1110              cd $dir              cd $dir
# Line 946  for dir in $TESTDIRS ; do Line 1115  for dir in $TESTDIRS ; do
1115    
1116      #  Verify that the testdir exists and contains previous      #  Verify that the testdir exists and contains previous
1117      #  results in the correct location--or skip this directory!      #  results in the correct location--or skip this directory!
1118      fout=      fout=$dir"/results/"$ref_outp
     if test "x$ADM" = x ; then  
         fout=$dir"/results/output.txt"  
     else  
         fout=$dir"/results_ad/output.txt_adm"  
     fi  
1119      if test ! -r $fout ; then      if test ! -r $fout ; then
1120          echo "can't read \"$fout\" -- skipping $dir"          echo "can't read \"$fout\" -- skipping $dir"
1121          continue          continue
# Line 962  for dir in $TESTDIRS ; do Line 1126  for dir in $TESTDIRS ; do
1126    
1127      # Check for additional types of monitor output      # Check for additional types of monitor output
1128    
1129      builddir="input"      if test ! -r $CODE_DIR"/SIZE.h_mpi" -a "x$MPI" = "xt" ; then
1130      rundir="input"          echo "can't find \"$CODE_DIR/SIZE.h_mpi\" -- skipping $dir"
1131      use_seperate_build=0          continue
     if test -d $dir/build -a -r $dir/build ; then  
         builddir="build"  
         rundir="build"  
         use_seperate_build=1  
         linkdata $use_seperate_build $dir/$rundir  
1132      fi      fi
1133            if test ! -r $dir"/input/eedata.mth" -a "x$MULTI_THREAD" = "xt" ; then
1134            echo "can't find \"$dir/input/eedata.mth\" -- skipping $dir"
1135            continue
1136        fi
1137    
1138      #  Check whether there are "extra runs" for this testdir      #  Check whether there are "extra runs" for this testdir
1139      extra_runs=      extra_runs=
1140      if test "x$ADM" = x -a "x$use_seperate_build" = x1 ; then      ex_run_dirs=`( cd $dir ; echo $inputdir.* )`
1141          ex_run_dirs=`( cd $dir ; echo input.* )`      #echo "ex_run_dirs='$ex_run_dirs'"
1142          echo "ex_run_dirs='$ex_run_dirs'"      for exd in $ex_run_dirs ; do
1143          for exd in $ex_run_dirs ; do          name=`echo $exd | sed -e "s/$inputdir\.//"`
1144              name=`echo $exd | sed -e 's/input.//g'`          refExOut=`echo $ref_outp | sed "s/\./.${name}./"`
1145              outf="$dir/results/output.txt.$name"          outf="$dir/results/$refExOut"
1146              if test -f $outf -a -r $outf ; then          if test -f $outf -a -r $outf ; then
1147                if test "x$MULTI_THREAD" = "xt" ; then
1148                    if test -r $dir"/"$exd"/eedata.mth" ; then
1149                        extra_runs="$extra_runs $name"
1150                    #else echo $dir"/"$exd"/eedata.mth: not found"
1151                    fi
1152                else
1153                  extra_runs="$extra_runs $name"                  extra_runs="$extra_runs $name"
1154              fi              fi
1155          done          fi
1156      fi      done
   
     if test "x$ADM" = x ; then  
         code_dir=code  
         CODE_DIR=$dir/code  
     else  
         code_dir=code_ad  
         CODE_DIR=$dir/code_ad  
     fi  
     BUILD_DIR=$dir/$builddir  
   
     if test ! -r $CODE_DIR"/SIZE.h_mpi" -a "x$MPI" = "xt" ; then  
         echo "can't find \"$CODE_DIR/SIZE.h_mpi\" -- skipping $dir"  
         continue  
     fi  
1157    
1158      echo "-------------------------------------------------------------------------------"      echo "-------------------------------------------------------------------------------"
1159      echo      echo
1160      echo "Experiment:  $dir"      if test "x$extra_runs" = "x" ; then
1161           echo "Experiment:  $dir"
1162        else
1163           echo "Experiment:  $dir ; extra_runs=$extra_runs"
1164        fi
1165      echo      echo
1166      unset genmake makedepend make run      unset genmake makedepend make run
1167      results='-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- --'      results=$EMPTY_RESULTS
1168    
1169      #  Create an output dir for each OPTFILE/tdir combination      #  Create an output dir for each OPTFILE/tdir combination
1170      rel_CDIR=$DRESULTS"/"$dir      rel_CDIR=$DRESULTS"/"$dir
# Line 1013  for dir in $TESTDIRS ; do Line 1172  for dir in $TESTDIRS ; do
1172      CDIR=`pwd`"/$rel_CDIR"      CDIR=`pwd`"/$rel_CDIR"
1173            
1174      if test "x$CLEANUP" = xt ; then      if test "x$CLEANUP" = xt ; then
1175          makeclean $dir/$builddir          echo '====>>> this is to check that we never go through this part <<< ==='
1176            makeclean $dir/$builddir \
1177                && run_clean $dir/$rundir
1178      else      else
1179          genmakemodel $dir/$builddir && genmake=Y \          genmakemodel $dir/$builddir && genmake=Y \
1180              && makeclean $dir/$builddir \              && makeclean $dir/$builddir \
1181                && run_clean $dir/$rundir \
1182              && symlink_mpifiles $dir $code_dir $builddir \              && symlink_mpifiles $dir $code_dir $builddir \
1183              && makedependmodel $dir/$builddir && makedepend=Y \              && makedependmodel $dir/$builddir && makedepend=Y \
1184              && makemodel $dir/$builddir && make=Y \              && makemodel $dir/$builddir && make=Y \
1185              && linkdata $use_seperate_build $dir/$rundir \              && linkdata $dir/$rundir $inputdir input \
1186              && runmodel $dir/$rundir && run=Y \              && runmodel $dir/$rundir && run=Y \
1187              && results=`testoutput $dir $rundir`              && results=`testoutput_run $dir $rundir $ref_outp`
1188      fi      fi
1189            
1190      echo      echo
     if test "x$ADM" = x ; then  
1191          fres=`formatresults $dir ${genmake:-N} ${makedepend:-N} ${make:-N} ${run:-N} $results`          fres=`formatresults $dir ${genmake:-N} ${makedepend:-N} ${make:-N} ${run:-N} $results`
1192          echo          echo
1193          echo "$fres" >> $SUMMARY          echo "$fres" | sed 's/ 99/ --/g' | sed 's/  > />/' | sed 's/  < /</' >> $SUMMARY
1194          echo "fresults='$fres'" > $CDIR"/summary.txt"          touch $CDIR"/summary.txt"
1195            echo "fresults='$fres'" | sed 's/ 99/ --/g' >> $CDIR"/summary.txt"
1196          echo "MACH='$MACH'" >> $CDIR"/summary.txt"          echo "MACH='$MACH'" >> $CDIR"/summary.txt"
1197          echo "UNAMEA='$UNAMEA'" >> $CDIR"/summary.txt"          echo "UNAMEA='$UNAMEA'" >> $CDIR"/summary.txt"
1198          echo "DATE='$DATE'" >> $CDIR"/summary.txt"          echo "DATE='$DATE'" >> $CDIR"/summary.txt"
1199          echo "tdir='$dir'" >> $CDIR"/summary.txt"          echo "tdir='$dir'" >> $CDIR"/summary.txt"
1200            if test "x$ADM" = xt ; then
1201                head -1 $dir/$builddir/taf_ad.log >> $CDIR"/summary.txt"
1202                grep -A3 'Seconds in section "ALL' $dir/$rundir/$OUTPUTFILE \
1203                                    >> $CDIR"/summary.txt"
1204            fi
1205    
1206          for ex in $extra_runs ; do          for ex in $extra_runs ; do
1207              unset run              unset run
1208              results='-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- --'              results=$EMPTY_RESULTS
1209                #  reference output file
1210                refExOut=`echo $ref_outp | sed "s/\./.${ex}./g"`
1211              #  Create an output dir for each OPTFILE/tdir.ex combination              #  Create an output dir for each OPTFILE/tdir.ex combination
1212              rel_CDIR=$DRESULTS"/"$dir"."$ex              rel_CDIR=$DRESULTS"/"$dir"."$ex
1213              mkdir $rel_CDIR              mkdir $rel_CDIR
1214              CDIR=`pwd`"/$rel_CDIR"              CDIR=`pwd`"/$rel_CDIR"
1215              test ! -e "$dir/tr_run.$ex" && mkdir "$dir/tr_run.$ex"              test ! -e "$dir/tr_run.$ex" && mkdir "$dir/tr_run.$ex"
1216              for ldir in input.$ex input ; do              run_clean $dir/tr_run.$ex
1217                  (              linkdata $dir/tr_run.$ex $inputdir.$ex $inputdir input
                     cd "$dir/$ldir" > /dev/null 2>&1  
                     ls -1 2>/dev/null \  
                         | sed -e 's|^CVS$||g' | sed -e 's|^output.txt$||g'  
                 ) > tr_exrun_links  
                 (  
                     cd "$dir/tr_run.$ex"  
                     cat ../../tr_exrun_links | while read i ; do  
                         if test ! "x$i" = x ; then  
                             test ! -r $i  &&  ln -s "../"$ldir"/"$i $i  
                         fi  
                     done  
                 )  
                 test -e tr_exrun_links  &&  rm -f tr_exrun_links  
             done  
             ldir=build  
             (  
                 cd $dir/tr_run.$ex  
                 test ! -e mitgcmuv  &&  ln -s "../"$ldir"/"mitgcmuv .  
             )  
1218              runmodel $dir/tr_run.$ex && run=Y \              runmodel $dir/tr_run.$ex && run=Y \
1219                  && results=`testoutput $dir tr_run.$ex "."$ex`              && results=`testoutput_run $dir tr_run.$ex $refExOut`
             fres=`printf '%s %s %s %s' ${genmake:-N} ${makedepend:-N} ${make:-N} ${run:-N}`  
1220              fres=`formatresults $dir ${genmake:-N} ${makedepend:-N} ${make:-N} ${run:-N} $results`              fres=`formatresults $dir ${genmake:-N} ${makedepend:-N} ${make:-N} ${run:-N} $results`
1221              fres="$fres.$ex"              fres="$fres.$ex"
1222              echo              echo
1223              echo "$fres" >> $SUMMARY              echo "$fres" | sed 's/ 99/ --/g' | sed 's/  > />/' | sed 's/  < /</' >> $SUMMARY
1224              echo "fresults='$fres'" > $CDIR"/summary.txt"              touch $CDIR"/summary.txt"
1225                echo "fresults='$fres'" | sed 's/ 99/ --/g' >> $CDIR"/summary.txt"
1226              echo "MACH='$MACH'" >> $CDIR"/summary.txt"              echo "MACH='$MACH'" >> $CDIR"/summary.txt"
1227              echo "UNAMEA='$UNAMEA'" >> $CDIR"/summary.txt"              echo "UNAMEA='$UNAMEA'" >> $CDIR"/summary.txt"
1228              echo "DATE='$DATE'" >> $CDIR"/summary.txt"              echo "DATE='$DATE'" >> $CDIR"/summary.txt"
1229              echo "tdir='$dir.$ex'" >> $CDIR"/summary.txt"              echo "tdir='$dir.$ex'" >> $CDIR"/summary.txt"
1230                if test "x$ADM" = xt ; then
1231                    head -1 $dir/$builddir/taf_ad.log >> $CDIR"/summary.txt"
1232                    grep -A3 'Seconds in section "ALL' $dir/tr_run.$ex/$OUTPUTFILE \
1233                                       >> $CDIR"/summary.txt"
1234                fi
1235                if test "x$POSTCLEAN" = xt ; then
1236                    run_clean $dir/tr_run.$ex
1237                fi
1238          done          done
     else  
         fres=`printf '%s %s %s %s' ${genmake:-N} ${makedepend:-N} ${make:-N} ${run:-N}`  
         fres=$fres"$results   $dir"  
         echo  
         echo "$fres" >> $SUMMARY  
         echo "fresults='$fres'" > $CDIR"/summary.txt"  
         echo "MACH='$MACH'" >> $CDIR"/summary.txt"  
         echo "UNAMEA='$UNAMEA'" >> $CDIR"/summary.txt"  
         echo "DATE='$DATE'" >> $CDIR"/summary.txt"  
         echo "tdir='$dir'" >> $CDIR"/summary.txt"  
         grep -A3 'Seconds in section "ALL' $dir/$rundir/$OUTPUTFILE \  
                            >> $CDIR"/summary.txt"  
     fi  
1239    
1240      postclean $dir/$builddir      #postclean $dir/$builddir
1241        if test "x$POSTCLEAN" = xt ; then
1242            makeclean $dir/$builddir \
1243                && run_clean $dir/$rundir
1244        fi
1245            
1246      echo "-------------------------------------------------------------------------------"      echo "-------------------------------------------------------------------------------"
1247            
# Line 1130  else Line 1279  else
1279      fi      fi
1280  fi  fi
1281    
1282  # rm -f tmp_cmpnum.f a.out  rm -f tr_cmpnum.c tr_cmpnum
 rm -f tmp_cmpnum.c tmp_cmpnum  
1283    
1284  if test "x$CLEANUP" != xt ; then  if test "x$CLEANUP" != xt ; then
1285      cat $SUMMARY | sed 's/ -- -- -- --//g'      cat $SUMMARY | sed 's/ \.  \.  \.  \.  \.  \.  \.  \.  \.  \.  \.  \. //'
1286      if test -e tr_out.txt ; then      if test -e tr_out.txt ; then
1287          mv tr_out.txt tr_out.txt.old          mv tr_out.txt tr_out.txt.old
1288      fi      fi
1289      cat $SUMMARY | sed 's/ -- -- -- --//g' > tr_out.txt      cat $SUMMARY | sed '/^[YN] [YN] [YN] [YN]/ s/ \. //g' > tr_out.txt
1290  fi  fi
1291    
1292  if test "x$DELDIR" = xt ; then  if test "x$DELDIR" = xt ; then

Legend:
Removed from v.1.77  
changed lines
  Added in v.1.112

  ViewVC Help
Powered by ViewVC 1.1.22